/* ========================================================================== */
/*                                                                            */
/*   flood-it.cpp                                                             */
/*   (c) 2001                                                        */
/*                                                                            */
/*   Description                                                              */
/*                                                                            */
/* ========================================================================== */
//#include <iostream>
#include <stdio.h>
using namespace std;

int Fill_arrReg();
int Fill_Regs(int, int, int);
int mk_lst();
int GetStartCell( int [] );
int GetXY(int ,int& , int&);
int GetMaxClr(int, int &);
int PaintReg(int, int);

struct t_Sq{
    int Clr; //  
    int Reg; //  
};


t_Sq ar1[350][350];

int ar2[350][350];
int N, C, BrRGN;
int arclr[500]; //    
int arregco[350];

int main(){
    int i, j, z, x, y, arm[350*350], arm1[350*350],j1;
    int strReg[350];

    //int clo = clock();
    
    FILE *f;
    f = fopen("flood-it.in","r");
    fscanf( f, "%d %d", &N, &C);			
    for(i=0;i<N;i++ ){
        for(j=0;j<N;j++ ){
            fscanf( f, "%d", &ar1[i][j].Clr);   
            arclr[ar1[i][j].Clr]++;
        }     
    }
    fclose(f); 


    
    //  
    BrRGN = Fill_arrReg(); 
    
    //    
    for(i=0;i<=BrRGN;i++ ){
        for(j=0;j<=BrRGN;j++ )
            ar2[i][j]=0;
    }
    
    // "  "
    mk_lst();

    
    //  . 
    //             
    GetStartCell(strReg);
        
    for (i=1;i<=4;i++){ 
        if (strReg[i]<=0) break;
        
        mk_lst();
        
        z = GetMaxClr (strReg[i],j);
        
        GetXY(strReg[i],x,y) ;
        
        arm[0]=x; arm[1]=y; arm[2]=z;
            
        //     .
        PaintReg (strReg[i],z);

        j=2;
        do{
            z = GetMaxClr (strReg[i],x);
            if (z){ 
                j++;
                arm[j]=z;
                PaintReg (strReg[i],z);  //     .            
            }
        } while (z>0);
        if (i==1){
            j1=j; 
            for (j=0 ; j<=j1; j++)
                arm1[j]=arm[j];
        }
        if (j<j1){
            j1=j;
            for (j=0 ; j<=j1; j++)
                arm1[j]=arm[j];
            }
        
    }
    
    //  
    f = fopen("flood-it.out","w");
    fprintf (f,"%d\n", (j1-1) );
    fprintf (f,"%d %d\n", arm1[0], arm1[1]);
    for (i=2 ; i<=j1; i++)
        fprintf (f,"%d\n", arm1[i]);
    fclose(f); 
    
    //cout << endl << (clock() - clo) << endl;
    // system("PAUSE");
    return 0;
}
 
int Fill_arrReg(){
    int i, j, z;
    z=1;
    for(i=0; i<N; i++){
        for(j=0; j<N; j++){
            if(ar1[i][j].Reg==0){
                ar1[i][j].Reg=z;
                arregco[z]=1;
                Fill_Regs(i,j,z);
                z++;
            }    
        }
    }
    return z-1;
}

int Fill_Regs(int i, int j, int reg){
    int k, z, i1, j1;
    for(k=0; k<4; k++){
        switch(k){
            case 0://
                z=((i-1)>=0)?(i-1):-1;  
                i1=z; j1=j;
                break;
            case 1://
               z=((i+1)<N)?(i+1):-1;
               i1=z; j1=j;
                break;
            case 2://
               z=((j+1)<N)?(j+1):-1;
               i1=i; j1=z;
               break;
            case 3://
               z=((j-1)>=0)?(j-1):-1;
               i1=i; j1=z;
               break;
            default:
                z=-1;
        } 
        if (z>=0){
            if (ar1[i1][j1].Reg==0){
                if (ar1[i1][j1].Clr==ar1[i][j].Clr){
                    ar1[i1][j1].Reg=reg;
                    arregco[reg]++;
                    Fill_Regs(i1,j1,reg);
                }
            }   
        }
        
    }
    return 0;
}
int mk_lst(){
    // "  "
    int i, j, k, l, z;
    for(i=0; i<N; i++){
        for(j=0; j<N; j++){                            
            l=((j+1)<N)?(j+1):-1;       //  
            if (l>=0) {
                k = ar1[i][j].Reg;     //                   
                z = ar1[i][l].Reg;     //   
                if (k!=z){
                    ar2[k][z] = ar1[i][l].Clr;
                    ar2[z][k] = ar1[i][j].Clr;
                }
            }
            l=((i+1)<N)?(i+1):-1;       //  
            if (l>=0) {
                k = ar1[i][j].Reg;     //                   
                z = ar1[l][j].Reg;     //   
                if (k!=z){
                    ar2[k][z] = ar1[l][j].Clr;
                    ar2[z][k] = ar1[i][j].Clr;
                }
            }
        }
    }
    
}

int GetStartCell(int arx[]){
    //
    //       
    // 
    //   -   
    //  
    //   ,    ,  x  y  
    int i, j, z, max, ind[BrRGN];
    max=0;
    for(i=1;i<=BrRGN;i++){
        GetMaxClr(i, ind[i]);
        arx[i]=i;//nomer na region        
    }
    //sort na arx    
    for(i=1;i<=BrRGN-1 ;i++ ){
        z=i;max=ind[z];
        for(j=i+1;j<=BrRGN ;j++ ){
            if (max<ind[j]){
                z=j;max=ind[j];
            }
        }
        if (i!=z){
            ind[z]=ind[i];
            ind[i]=max;
            j=arx[i];arx[i]=arx[z];arx[z]=j;
        }
    }    
    
    
    return 0;
}

int GetMaxClr(int r, int &br ){
    //        -  
    //          
    
    int i, h, c1[C];
    for(i=0; i<=C; i++)
        c1[i]=0;// c1

    
    for(i=1; i<=BrRGN ;i++){
        h=ar2[r][i];//,   .   ??? 
        if(h)  
            c1[h]+=arregco[i] ;//    
    }   
    //      
    for(i=1; i<=C ;i++){
        if(c1[i]){
            h=arclr[i];
            c1[i]=int((float( c1[i])/float(h))*100);
        }
    }
    
    //-
    h=0; br=c1[h] ;
    for(i=1; i<=C ;i++){
        if (c1[h]<c1[i]){ 
            h=i; 
            br=c1[h];
        }
    }
    return h;
    
}

int PaintReg(int NomReg, int color){
    //     .    
    //       .
    //       
    // NomReg
    
    int i,j,z;  
    
    j=ar2[i][NomReg];// 
    //         . 
    for (i=1;i<=BrRGN;i++){
        if (ar2[i][NomReg]>0)
           ar2[i][NomReg]=color;
    }
    //    
    arclr[j]-= arregco[NomReg];
    arclr[color]+= arregco[NomReg];


    //      
    for (i=1;i<=BrRGN;i++){
        if (ar2[NomReg][i]==color){
            //       [i]
            //        [i]
            
            ar2[i][NomReg]=0;            

            for (j=1;j<=BrRGN;j++){
                if (ar2[i][j]>0){ 
                    ar2[NomReg][j]=ar2[i][j]; //      
                    ar2[i][j] = 0;
                    
                    ar2[j][NomReg]=color;//         
                    ar2[j][i]=0;         //      
                    ar2[i][j]=0;
                }
            }
            ar2[NomReg][i]=0;
           
         }
    }
    
}
 
int GetXY(int NomReg,int &x, int &y ){
   //      
    int i, j, z;
    z=0;x=0;y=0;
    for(i=0;i<N;i++){
        for(j=0;j<N;j++){
            if (ar1[i][j].Reg==NomReg){
               x=i;y=j;z=1;break;
            }
        }
        if (z==1) break;
    } 
    return 0;
}

//function Next_Move(){
//    GetMaxClr_
//    

//}
















